﻿namespace IMSES_Template.Model
{
    /// <summary>
    /// The Servers that can be chosen, the actual value is noted in the settings file. 
    /// </summary>
    public enum ItslearningServers
    {
        Production,
        Beta,
        Test,
    }

    /// <summary>
    /// The result status of an OperationResult.
    /// </summary>
    public enum ResultStatus
    {
        Error,
        Warning,
        Success,
    }

    /// <summary>
    /// Profile of a User.
    /// </summary>
    public enum Profile         // InstitutionRoleDTypeInstitutionRoleType
    {
        Guest,                  // Guest
        Pupil,                  // Student
        Staff,                  // Staff
        Administrator,          // Administrator
        SystemAdministrator,    // Learner
    }

    /// <summary>
    /// Roles that a User can have in a Hierarchy.
    /// Note: these roles are mapped to the commented ImsEs roles. In the default settings in Itslearning these are mapped back to the given roles, 
    /// but this mapping can be changed, throwing off this mapping. Keep this in mind when changing the mapping of roles in Itslearning!
    /// </summary>
    public enum HierarchyRole   // RoleDTypeRoleType
    {
        Guest,                  // Member
        Pupil,                  // Learner 
        Mentor,                 // Mentor
        Teacher,                // Instructor
        Administrator,          // Administrator
    }

    /// <summary>
    /// The group types of an Hierarchy, for getting.
    /// </summary>
    public enum GroupType
    {
        Hierarchy = -1,
        Site = 0,
        School = 1,
        Course = 2,
        CourseGroup = 3,
    }

    /// <summary>
    /// The possible Name fields, for making the code type safe.
    /// </summary>
    public enum NameFieldType
    {
        First,
        Last,
        Nick,
        Undefined,
    }

    /// <summary>
    /// The possible Extension fields for Users, for making the code type safe.
    /// </summary>
    public enum ExtensionFieldType
    {
        Nationalidentitynumber,
        Customstring0,
        Customstring1,
        Customstring2,
        Customstring3,
        Customstring4,
        
        EmailserverEmail,
        EmailserverServer,
        EmailserverPort,
        EmailserverType,
        EmailserverUserid,
        EmailserverUseridPassword,

        MetaData,
        Undefined,
    }

    /// <summary>
    /// The possible Extension fields for Hierarchies and Courses, for making the code type safe.
    /// </summary>
    public enum CourseExtFieldType
    {
        Visibleinsearch,
        Course,
        CourseCode,
        CourseCredits,
        Undefined,
    }

    /// <summary>
    /// The possible Extension fields for a Membership, for making the code type safe.
    /// </summary>
    public enum MembershipExtFieldType
    {
        HomeOrganisation,
        Undefined,
    }

    /// <summary>
    /// Bool types, for making the code type safe.
    /// </summary>
    public enum BoolFieldType
    {
        True,
        False,
        Undefined,
    }


}
